package com.gic.haoban.manage.web.controller;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.StaffDTO;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.web.anno.IgnoreLogin;
import com.gic.haoban.manage.web.auth.AuthRequestUtil;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.vo.LoginVO;
import com.gic.wechat.api.service.qywx.QywxCorpApiService;


@RestController
public class LoginController extends WebBaseController{
	
	private static Logger logger= LoggerFactory.getLogger(LoginController.class);
	@Autowired
	StaffApiService staffApiService;
	
	@Autowired
	private QywxCorpApiService qywxCorpApiService;
	
	public static final  String siteId = "ww7d6566614055cf27";
	
	public static final String redirectUri = "https://www.gicdev.com/haoban-manage3-web/login";
	
	@RequestMapping("login")
	public HaobanResponse login(String code) {
		String userId = qywxCorpApiService.getUserInfoSimple(siteId,code);
		StaffDTO loginStaff = staffApiService.selectByUserId(userId);

		LoginVO loginVO = new LoginVO();
		StaffDTO staff = staffApiService.selectById("1");
		logger.info("【好办登录】staff={}",JSON.toJSONString(staff));
		loginVO.setWxEnterpriseId(staff.getWxEnterpriseId());
		loginVO.setStaffDTO(staff);
		AuthRequestUtil.setSessionUser(loginVO);
		return resultResponse(HaoBanErrCode.ERR_1, loginVO);
		
	}
	
	@RequestMapping("get-login-qrcode")
	public HaobanResponse getLoginQrcode(){
		String url = "https://open.work.weixin.qq.com/wwopen/sso/3rd_qrConnect?appid=wweac4ef962720aa12&"+redirectUri+"&state=web_login@gyoss9&usertype=admin";
		//String url = qywxCorpApiService.getGrantAuthorizationUrl(siteId, redirectUri);
		return resultResponse(HaoBanErrCode.ERR_1,url);
		
	}
	//运维登录
	@IgnoreLogin
	@RequestMapping("yw-login")
	public HaobanResponse ywLogin(String wxEnterpriseId) {
		//TODO 获取超级管理员账号接口
		StaffDTO staff = new StaffDTO();
		
		
		
		LoginVO loginVO = new LoginVO();
		loginVO.setWxEnterpriseId(wxEnterpriseId);
		loginVO.setStaffDTO(staff);
		AuthRequestUtil.setSessionUser(loginVO);
		return resultResponse(HaoBanErrCode.ERR_1, loginVO);
	}
	
	@RequestMapping("login-out")
	public HaobanResponse loginOut() {
		
		AuthRequestUtil.delSessionUser();
		return resultResponse(HaoBanErrCode.ERR_1);
		
	}

}
